SystemOrganization addCategory: #STTutTodoApp!

WATask subclass: #StRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StRootTask class methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 18:22'!
canBeRoot 
	^true! !

!StRootTask methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 21:27'!
go
	|loginAnswer user|
	loginAnswer := self call: StLoginComponent new.
	loginAnswer = #registerUser 
		ifTrue: [user := self call: StRegisterComponent new.]
		ifFalse: [user := loginAnswer].
	user ifNotNil: [
		self session login: user.
		self call: StLoggedInComponent new.]! !

WAFileLibrary subclass: #StToDoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StToDoLibrary class methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 19:37'!
applicationName 
	^'ToDo Application'! !

!StToDoLibrary methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 19:37'!
selectorsToInclude 
	^#( todoCss )! !

!StToDoLibrary methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 19:36'!
todoCss

 ^ '
body {
 font: normal 100% Arial, Helvetica, Verdana, sans-serif;
}
 
.generic {
 font-family: Geneva, Arial, Helvetica, sans-serif;
 font-style: normal;
 font-weight: normal;
 font-size: 14px;
 color : #663300;
 padding: 20px;
 margin-top: 20px;
 margin-left: 20px;
 border: 1px solid #663300;
 width: 500px;
}

.lightbox {
 background-color:#FFFFFF;
}

.errorMessage {
 background-color: #ffb0b0;
 border: 1px solid #ee0000;
 padding: 5px;
 margin-bottom: 10px;
}

.infoMessage {
 background-color: #fbffcc;
 border: 1px solid #eda33a;
 padding: 5px;
 margin-bottom: 10px;
}

.copyright {
 font-family: Geneva, Arial, Helvetica, sans-serif;
 font-size: 10px;
 font-style: normal;
 font-weight: normal;
 color: #663300;
 text-align: left;
 margin-left: 20px;
}

a {
 color : #663300;
 text-decoration: underline;
}'! !

!StToDoLibrary methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 19:35'!
updateRoot: anHtmlRoot
	
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet 
		url: StToDoLibrary / #mainCss.
	anHtmlRoot javascript
		url: StToDoLibrary / #mainJs.! !

WAComponent subclass: #StListComponent
	instanceVariableNames: 'items filterBlock sortBlock renderItemBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StListComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:42'!
filterBlock
	^ filterBlock! !

!StListComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:42'!
filterBlock: anObject
	filterBlock := anObject! !

!StListComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:42'!
items
	^ items! !

!StListComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:42'!
items: anObject
	items := anObject! !

!StListComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 20:43'!
renderContentOn: html

html table: [ (self sortBlock 
	value: (self filterBlock value: self items))
	do: [:item| html tableRow: [ self renderItemBlock 
								value: item
								value: html ]]].! !

!StListComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:42'!
renderItemBlock
	^ renderItemBlock! !

!StListComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:42'!
renderItemBlock: anObject
	renderItemBlock := anObject! !

!StListComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:42'!
sortBlock
	^ sortBlock! !

!StListComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:42'!
sortBlock: anObject
	sortBlock := anObject! !

WAComponent subclass: #StLoggedInComponent
	instanceVariableNames: 'listComponent menuComponent taskEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StLoggedInComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/8/2013 15:48'!
buildComponentFor: aModel
	^ aModel asComponent addValidatedForm ! !

!StLoggedInComponent methodsFor: 'hooks' stamp: 'RonnieGarduno 2/6/2013 20:34'!
children
^ Array with: self menuComponent with: self listComponent! !

!StLoggedInComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/8/2013 16:27'!
createNewTask 
	
| answer |
answer := self call: self taskEditor newTask.
answer ifTrue: [self listComponent items add: self taskEditor task].! !

!StLoggedInComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 22:19'!
editTask: aTask
	self taskEditor task: aTask copy.
	(self lightbox: self taskEditor ) ifFalse: [^self].
	aTask copyFrom: self taskEditor task.
	self session database updateTask: aTask.! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'RonnieGarduno 2/8/2013 16:49'!
effects
 ^ #( appear fade puff blindDown blindUp switchOff slideDown slideUp dropOut shake pulsate squish fold grow shrink highlight )! !

!StLoggedInComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 21:17'!
findUserByEmail: anEmail
	^ self database findUserByEmail: anEmail! !

!StLoggedInComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 22:57'!
highlight: anEffect
	^ anEffect highlight; color: '#f00'! !

!StLoggedInComponent methodsFor: 'initialization' stamp: 'RonnieGarduno 2/7/2013 21:35'!
initialize 
	super initialize.
	self initializeMenuComponent.
	self initializeListComponent.
	self taskEditor: StTaskEditor new.! !

!StLoggedInComponent methodsFor: 'initialization' stamp: 'RonnieGarduno 2/7/2013 21:14'!
initializeListComponent 

	self listComponent: StListComponent new.
	self listComponent 
		sortBlock: [:items | 
			items sort: [:a :b | a deadline < b deadline ]];
		renderItemBlock: [:task :html |
			self renderTask: task asRowOn: html ];
		items: self session user tasks.
	self showPendingTasks.! !

!StLoggedInComponent methodsFor: 'initialization' stamp: 'RonnieGarduno 2/7/2013 19:00'!
initializeMenuComponent

self menuComponent: (StMenuComponent new
	addEntry: 'All' withAction: [self showAllTasks ];
	addEntry: 'Completed' withAction: [self showCompletedTasks ];
	addEntry: 'Pending' withAction: [self showPendingTasks ];
	addEntry: 'Missed' withAction: [self showMissedTasks ];
	addEntry: 'New Task' withAction: [self createNewTask ];
	addEntry: 'Logout' withAction: [self session logout. self answer true];
	yourself).! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:31'!
listComponent
	^ listComponent! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:31'!
listComponent: anObject
	listComponent := anObject! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:31'!
menuComponent
	^ menuComponent! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:31'!
menuComponent: anObject
	menuComponent := anObject! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'RonnieGarduno 2/8/2013 17:21'!
renderBox: aString on: html
	html div id: aString; class: 'box'; with: [
		html div class: 'header'.
		html div
			class: 'content';
			with: 'Smalltalk Enterprise Aubergines' ]! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'RonnieGarduno 2/7/2013 23:19'!
renderBoxOn: html
	html div class: 'pack'; with: [
		html div 
			id: 'box';
			class: 'box';
			class: 'blue' ]! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'RonnieGarduno 2/7/2013 22:08'!
renderCheckboxWith: aTask on: html	
	|updater| 
	updater := html prototype updater 
		id: 'list';
		callback: [:renderer | 
			aTask completed: aTask completed not.
			renderer render: self listComponent ];
		yourself.
	html checkbox 
		onClick: updater;
		value: aTask completed. ! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'RonnieGarduno 2/8/2013 16:48'!
renderContentOn: html
	
	html div
		class: 'generic';
		with:[
			html heading: 'ToDo-List of ', self session user userName.
			html div
				class: 'menu';
				with: self menuComponent.
			html div
				class: 'list';
				with: self listComponent.
			"html anchor onClick: 
				(self perform: #highlight asMutator
				with: (html jQuery: '.box') effect);
				with: #highlight	]."
			html horizontalRule.
			html anchor onClick: (html jQuery: '.box') toggle; with: 'toggle'].
			self renderBoxOn: html.
			html break.
			html paragraph: [
 			     self effects do: [ :each |
			         html anchor
   			         onClick: (html scriptaculous effect
      		         id: 'effect';
        		         perform: each);
            		with: (self labelForSelector: each) ]
        		      separatedBy: [ html text: ', ' ] ].
			self renderBox: 'effect' on: html! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'RonnieGarduno 2/7/2013 22:13'!
renderInPlaceEditorWith: aTask on: html
	| editor |
	editor := html scriptaculous inPlaceEditor 
		cancelControl: false;
		triggerInPlaceEditor: [:value | aTask taskName: value];
		callback: [:renderer | renderer render: aTask taskName ];
		yourself.
	html div 
		script: editor;
		with: aTask taskName.! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'RonnieGarduno 2/7/2013 22:14'!
renderTask: aTask asRowOn: html
	
	html tableData: [
		html 
			tableData:	[self renderCheckboxWith: aTask on: html];
			tableData: aTask deadline asString;
			tableData: [self renderInPlaceEditorWith: aTask on: html];
			tableData: aTask taskDescription;
			tableData: [ html anchor
				callback: [self editTask: aTask]; with: 'edit']].! !

!StLoggedInComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 21:18'!
responseForRequest: aRequest
	
	self database connectionFailed 
		ifTrue: [^WAResponse new nextPutAll: 'No database connection.'].
	^super responseForRequest: aRequest! !

!StLoggedInComponent methodsFor: 'filters' stamp: 'RonnieGarduno 2/6/2013 20:47'!
showAllTasks 
	self listComponent 
		filterBlock: [:items | items].! !

!StLoggedInComponent methodsFor: 'filters' stamp: 'RonnieGarduno 2/6/2013 20:47'!
showCompletedTasks 
	self listComponent 
		filterBlock: [:items | items select: [:item | item completed]]! !

!StLoggedInComponent methodsFor: 'filters' stamp: 'RonnieGarduno 2/6/2013 20:48'!
showMissedTasks 
	self listComponent 
		filterBlock: [:items | items select: [:item | item hasBeenMissed ]]! !

!StLoggedInComponent methodsFor: 'filters' stamp: 'RonnieGarduno 2/6/2013 20:46'!
showPendingTasks 
	self listComponent 
		filterBlock: [:items | items select: [:item | item isPending ]]! !

!StLoggedInComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/8/2013 17:18'!
style
	"^ '#theme { clear: both; float: right; margin: -40px 0 10px 0; }
#theme label { color: #fff; }
#theme select { outline: none; border: 1px solid #ddd; background-color: #fff; }
	
/* colors */
.blue { background-color: #68bfef; border: 2px solid #0090df; }
.red { background-color: #ef2929; border: 2px solid #cc0000; }
.green { background-color: #72d216; border: 2px solid #4e9a06; }
.brown { background-color: #e9b96e; border: 2px solid #c17d11; }

/* box */
.pack { position: relative; height: 110px; }
.box { float: left; width: 100px; height: 100px; margin-right: 1em; }'"
^ ''! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 21:34'!
taskEditor
	^taskEditor! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 21:09'!
taskEditor: anObject
	taskEditor := anObject! !

!StLoggedInComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 20:55'!
testTasks

^ OrderedCollection 
with: (StTask new 
	deadline: Date yesterday;
	completed: false;
	taskName: 'Missed task')
with: (StTask new
	deadline: Date tomorrow;
	completed: false;
	taskName: 'Pending task')
with: (StTask new
	deadline: Date tomorrow;
	completed: true;
	taskName: 'Already completed task')! !

WAComponent subclass: #StLoginComponent
	instanceVariableNames: 'email password messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StLoginComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 19:36'!
applicationName 
	^ StToDoLibrary applicationName ! !

!StLoginComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 18:27'!
email
	^ email! !

!StLoginComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 18:27'!
email: anObject
	email := anObject! !

!StLoginComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 18:59'!
loginFailed 
	self messageComponent errorMessage: 'Login failed.'.! !

!StLoginComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 19:22'!
messageComponent
	^ (messageComponent ifNil: [messageComponent:= StMessageComponent new.])! !

!StLoginComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 19:21'!
messageComponent: anObject
	messageComponent := anObject! !

!StLoginComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 18:27'!
password
	^ password! !

!StLoginComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 18:27'!
password: anObject
	password := anObject! !

!StLoginComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 18:59'!
registerUser 
	self answer: #registerUser.! !

!StLoginComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 18:30'!
renderContentOn: html
	html div
		class: 'generic';
		with: [
			html
				heading: self applicationName;
				render: self messageComponent;
				text: 'Please login with an e-mail and password';
				form: [
					self
						renderTextInputOn: html;
						renderPasswordInputOn: html;
						renderLoginButtonOn: html;
						renderSignUpAnchorOn: html
				]].! !

!StLoginComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 18:55'!
renderLoginButtonOn: html
	html submitButton 
		callback: [self validateLogin ];
		text: 'Login'.! !

!StLoginComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 18:54'!
renderPasswordInputOn: html
	html passwordInput
		callback: [:value | self password: (StUser hashPassword: value)];
		value: ''! !

!StLoginComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 19:24'!
renderSignUpAnchorOn: html
	html paragraph with: [html anchor
		callback: [self registerUser ];
		with: [html text: 'Sign up for the ', self applicationName ] ].! !

!StLoginComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 18:30'!
renderTextInputOn: html
	html textInput 
		on: #email of: self;
		value:''.
	html space.! !

!StLoginComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 18:58'!
validateLogin 
	|user|
	user := self session findUserByEmail: self email.
	(user notNil and: [user password = self password])
		ifTrue: [self answer: user]
		ifFalse: [self loginFailed].! !

WAComponent subclass: #StMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StMenuComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 20:35'!
addEntry: aString withAction: aBlock
	^ self entries add: aString -> aBlock! !

!StMenuComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:34'!
entries
	^ entries! !

!StMenuComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:34'!
entries: anObject
	entries := anObject! !

!StMenuComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 20:35'!
initialize 
	super initialize.
	self entries: OrderedCollection new.! !

!StMenuComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 20:39'!
renderContentOn: html

self entries
	do: [:entry |
		html anchor
			callback: entry value;
			with: entry key]
	separatedBy: [html space].! !

WAComponent subclass: #StMessageComponent
	instanceVariableNames: 'messageString messageType wasShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StMessageComponent methodsFor: 'initialization' stamp: 'RonnieGarduno 2/7/2013 19:17'!
errorMessage: aString
	self 	
		messageType: 'error';
		messageString: aString;
		wasShown: false.! !

!StMessageComponent methodsFor: 'initialization' stamp: 'RonnieGarduno 2/7/2013 19:18'!
infoMessage: aString
	self 
		messageString: aString;
	    	messageType: 'info';
		wasShown: false.! !

!StMessageComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 19:23'!
initialize 
	super initialize.
	self wasShown: true.! !

!StMessageComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 19:17'!
messageString
	^ messageString! !

!StMessageComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 19:17'!
messageString: anObject
	messageString := anObject! !

!StMessageComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 19:17'!
messageType
	^ messageType! !

!StMessageComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 19:17'!
messageType: anObject
	messageType := anObject! !

!StMessageComponent methodsFor: 'rendering' stamp: 'RonnieGarduno 2/7/2013 19:19'!
renderContentOn: html
	self wasShown ifTrue: [^ self].
	html div
		class: self messageType, 'Message';
		with: self messageString.
	self wasShown: true.! !

!StMessageComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 19:17'!
wasShown
	^ wasShown! !

!StMessageComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 19:17'!
wasShown: anObject
	wasShown := anObject! !

WAComponent subclass: #StRegisterComponent
	instanceVariableNames: 'user repeatedPassword messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StRegisterComponent methodsFor: 'initialization' stamp: 'RonnieGarduno 2/7/2013 19:27'!
initialize 
	super initialize.
	self user: StUser new.
	self messageComponent: StMessageComponent new.! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 19:27'!
messageComponent
	^ messageComponent! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 19:27'!
messageComponent: anObject
	messageComponent := anObject! !

!StRegisterComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 19:15'!
registerUser 
	
	self user userName isEmptyOrNil 
		ifTrue:   [ ^ self messageComponent infoMessage: 'Please choose a username!!'].
	self user email isEmptyOrNil 
		ifTrue:   [ ^ self messageComponent infoMessage: 'Please enter your e-mail address!!'].
	(self session findUserByEmail: self user email)
		ifNotNil: [ ^ self messageComponent errorMessage: 'The e-mail address is already registered!!' ].
	self user password = 0
		ifTrue: [ ^ self messageComponent infoMessage: 'Please choose a password!!'].
	self user password = self repeatedPassword
		ifFalse: [^ self messageComponent infoMessage: 'Your repeated password does not match!!'].
	self session database addUser: self user.
	self answer: self user.! !

!StRegisterComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 19:05'!
renderCancelButtonOn: html
	html submitButton 
		callback: [self answer: nil];
		text: 'Cancel'.! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'RonnieGarduno 2/7/2013 19:04'!
renderContentOn: html
	
	html div
		class: 'generic';
		with: [
			html
				heading: 'Register';
				render: self messageComponent;
				form: [
					html table:[
						self
							renderUsernameTextInputOn: html;
							renderEmailTextInputOn: html;
							renderPasswordTextInputOn: html;
							renderRepeatedPasswordTextInputOn: html.
						html tableRow: [
							html
								tableData;
								tableData: [
									self renderSubmitButtonOn: html.
									html space.
									self renderCancelButtonOn: html]]]]].! !

!StRegisterComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 19:08'!
renderEmailTextInputOn: html
	html tableRow: [
		html 
			tableData: 'E-mail';
			tableData: [
				html textInput
					callback: [:value | self user email: value];
					value: self user email]].! !

!StRegisterComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 21:26'!
renderPasswordTextInputOn: html
	html tableRow: [
		html 
			tableData: 'Password';
			tableData: [
				html passwordInput 
					callback: [:value | self user password:  (StUser hashPassword: value)]]].! !

!StRegisterComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 19:11'!
renderRepeatedPasswordTextInputOn: html
	html tableRow: [
		html 
			tableData: 'Repeat password';
			tableData: [
				html passwordInput 
					callback: [:value | self repeatedPassword: (StUser hashPassword: value )]]].! !

!StRegisterComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 19:05'!
renderSubmitButtonOn: html
	html submitButton 
		callback: [self registerUser ];
		text: 'Register'.! !

!StRegisterComponent methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 19:07'!
renderUsernameTextInputOn: html
	html tableRow: [
		html
		tableData: 'Username';
		tableData: [
			html textInput 
			callback: [:value | self user userName: value];
			value: self user userName ]].! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 18:27'!
repeatedPassword
	^ repeatedPassword! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 18:27'!
repeatedPassword: anObject
	repeatedPassword := anObject! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 18:27'!
user
	^ user! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 18:27'!
user: anObject
	user := anObject! !

WAComponent subclass: #StTaskEditor
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StTaskEditor methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 21:00'!
initialize 
	super initialize.
	self task: StTask new.! !

!StTaskEditor methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 21:15'!
newTask 
	self task: StTask new.! !

!StTaskEditor methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 21:08'!
renderButtonsOn: html
	html tableData;
		 tableData: [
			html submitButton 
				callback: [self answer: true];
				value: 'Save'.
			html submitButton 
				callback: [self answer: false];
				value: 'Cancel'.
			].! !

!StTaskEditor methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 21:06'!
renderCompletedSelectionOn: html
	html
		tableData: [html text: 'Completed: '];
		tableData: [
			html select
				add: true;
				add: false;
				on: #completed of: self task;
				labels: [:value |
					value
					ifTrue: ['yes']
					ifFalse: ['no']]].! !

!StTaskEditor methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 21:02'!
renderContentOn: html
	html div
		class: 'generic lightbox';
		with: [
			html heading: 'Editing task'.
			html form: [
				html table: [
					html
						tableRow: [self renderNameInputOn: html];
						tableRow: [self renderDescriptionInputOn: html];
						tableRow: [self renderDateInputOn: html];
						tableRow: [self renderCompletedSelectionOn: html];
						tableRow: [self renderButtonsOn: html]]]].! !

!StTaskEditor methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 21:04'!
renderDateInputOn: html
	html 
		tableData: [html text: 'Deadline: '];
		tableData: [html dateInput on: #deadline of: self task].! !

!StTaskEditor methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 21:03'!
renderDescriptionInputOn: html
	html 
		tableData: [html text: 'Description: '];
		tableData: [html textArea on: #taskDescription of: self task].! !

!StTaskEditor methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 21:03'!
renderNameInputOn: html
	html
		tableData: [html text: 'Name: '];
		tableData: [html textInput on: #taskName of: self task].! !

!StTaskEditor methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:59'!
task
	^ task! !

!StTaskEditor methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:59'!
task: anObject
	task := anObject! !

WASession subclass: #StSession
	instanceVariableNames: 'user database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StSession methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 21:19'!
database
	^ database! !

!StSession methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 21:19'!
database: anObject
	database := anObject! !

!StSession methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 21:22'!
findUserByEmail: anEmail
	^ self database findUserByEmail: anEmail! !

!StSession methodsFor: 'initialization' stamp: 'RonnieGarduno 2/7/2013 21:52'!
initialize 
	super initialize.
	self database: StSandstoneDatabase new.! !

!StSession methodsFor: 'testing' stamp: 'RonnieGarduno 2/7/2013 18:17'!
isLoggedIn 
	^ self user notNil ! !

!StSession methodsFor: 'actions' stamp: 'RonnieGarduno 2/7/2013 18:16'!
login: aUser
	self user: aUser.! !

!StSession methodsFor: 'actions' stamp: 'RonnieGarduno 2/7/2013 18:17'!
logout 
	self user: nil.! !

!StSession methodsFor: 'parent/child' stamp: 'RonnieGarduno 2/7/2013 21:12'!
unregistered 
	self database disconnect.
	super unregistered.! !

!StSession methodsFor: 'updating' stamp: 'RonnieGarduno 2/7/2013 19:39'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: StToDoLibrary applicationName.! !

!StSession methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 18:16'!
user
	^ user! !

!StSession methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 18:16'!
user: anObject
	user := anObject! !

SDActiveRecord subclass: #StUser
	instanceVariableNames: 'userName email tasks password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StUser class methodsFor: 'testing' stamp: 'RonnieGarduno 2/7/2013 19:28'!
hashPassword: aString
	^ aString
		ifEmpty: [0] 
		ifNotEmpty: [GRPlatform current secureHashFor: aString].! !

!StUser methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 20:28'!
addTask: aTask
	^self tasks add: aTask.! !

!StUser methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:27'!
email
	^ email! !

!StUser methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:27'!
email: anObject
	email := anObject! !

!StUser methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:27'!
id
	^ id! !

!StUser methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:27'!
id: anObject
	id := anObject! !

!StUser methodsFor: 'initialization' stamp: 'RonnieGarduno 2/7/2013 21:05'!
initialize 
	super initialize.
	self tasks: OrderedCollection new.! !

!StUser methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:27'!
password
	^ password! !

!StUser methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:27'!
password: anObject
	password := anObject! !

!StUser methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:27'!
tasks
	^ tasks! !

!StUser methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:27'!
tasks: anObject
	tasks := anObject! !

!StUser methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:27'!
userName
	^ userName! !

!StUser methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:27'!
userName: anObject
	userName := anObject! !

Object subclass: #StDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StDatabase methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 20:47'!
connect
	^true! !

!StDatabase methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 20:47'!
connectionFailed 
	^false! !

!StDatabase methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 20:47'!
disconnect 
	^false! !

StDatabase subclass: #StImageDatabase
	instanceVariableNames: ''
	classVariableNames: 'WriteMutex'
	poolDictionaries: ''
	category: 'STTutTodoApp'!

StImageDatabase class
	instanceVariableNames: 'Users'!

StImageDatabase class
	instanceVariableNames: 'Users'!

!StImageDatabase class methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 20:49'!
users
	^ Users ifNil: [Users := OrderedCollection new].! !

!StImageDatabase class methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 20:48'!
users: anObject
	Users := anObject! !

!StImageDatabase class methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 20:50'!
writeMutex 
	^WriteMutex ifNil: [WriteMutex := Monitor new].! !

!StImageDatabase methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 20:52'!
addTask: aTask toUser: aUser
	aUser addTask: aTask.
	self saveImage.
	^ aTask! !

!StImageDatabase methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 20:51'!
addUser: aUser
	self class users add: aUser.
	self saveImage.
	^ aUser.! !

!StImageDatabase methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 20:53'!
findUserByEmail: anEmail 
	
	^ self class users 
		detect: [:each | each email = anEmail]
		ifNone: [nil]! !

!StImageDatabase methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 20:51'!
saveImage 
	self class writeMutex critical: [self saveImageWithoutMonitor ].! !

!StImageDatabase methodsFor: 'accessing' stamp: 'RonnieGarduno 2/7/2013 20:50'!
saveImageWithoutMonitor 
	SmalltalkImage current saveSession.! !

!StImageDatabase methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 20:53'!
updateTask: aTask
	self saveImage.! !

StDatabase subclass: #StSandstoneDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StSandstoneDatabase class methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 21:06'!
initialize 
	SDActiveRecord warmUpAllClasses.! !

!StSandstoneDatabase methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 21:07'!
addTask: aTask toUser: aUser
	aUser addTask: aTask.
	aUser save.
	^ aTask! !

!StSandstoneDatabase methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 21:06'!
addUser: aUser
	aUser save.
	^aUser! !

!StSandstoneDatabase methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 21:08'!
findUserByEmail: aString
	^ StUser find: [:each | each email = aString]! !

!StSandstoneDatabase methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 21:08'!
updateTask: aTask
	| user | 
	user := StUser find: [:each | each tasks includes: aTask].
	user save.! !

Object subclass: #StTask
	instanceVariableNames: 'completed deadline taskDescription taskName id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StTask methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:28'!
completed
	^ completed! !

!StTask methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:28'!
completed: anObject
	completed := anObject! !

!StTask methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:28'!
deadline
	^ deadline! !

!StTask methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:28'!
deadline: anObject
	deadline := anObject! !

!StTask methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/7/2013 22:50'!
descriptionCompleted

	^ MABooleanDescription new
		selectorAccessor: #completed;
		label: 'Completed?';
		priority: 30;
		default: false;
		yourself.! !

!StTask methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/8/2013 15:05'!
descriptionDeadline
	^ MADateDescription new
		selectorAccessor: #deadline;
		label: 'Deadline';
		priority: 20;
		default: Date today;
		yourself ! !

!StTask methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/8/2013 15:06'!
descriptionTaskDescription
	^ MAMemoDescription new
		selectorAccessor: #taskDescription;
		label: 'Description';
		priority: 40;
		default: '';
		yourself! !

!StTask methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/8/2013 15:39'!
descriptionTaskName
	^ MAStringDescription new
		selectorAccessor: #taskName;
		label: 'Task Name';
		priority: 10;
		default: 'New Task';
		addCondition: [:value | (value ~= 'New Task')
			and: [value size <= 50]] 
		labelled: 'Task name is invalid or too long';
		yourself ! !

!StTask methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 20:58'!
hasBeenMissed 
	^self completed not and: [self deadline < Date today ]! !

!StTask methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:28'!
id
	^ id! !

!StTask methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:28'!
id: anObject
	id := anObject! !

!StTask methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 20:29'!
initialize 
	self
		deadline: Date tomorrow;
		completed: false.! !

!StTask methodsFor: 'as yet unclassified' stamp: 'RonnieGarduno 2/6/2013 20:29'!
isPending 
	^self completed not and: [self deadline >= Date today]! !

!StTask methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:28'!
taskDescription
	^ taskDescription! !

!StTask methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:28'!
taskDescription: anObject
	taskDescription := anObject! !

!StTask methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:28'!
taskName
	^ taskName! !

!StTask methodsFor: 'accessing' stamp: 'RonnieGarduno 2/6/2013 20:28'!
taskName: anObject
	taskName := anObject! !
StSandstoneDatabase initialize!
